<?php

class ArchiveStreamer {
	
	public static function die__streamArchive() {
		self::streamArchive();
		die(0);
	}
	
	public static function streamArchive() {
		$flist = self::writeFileList();
		
		ini_set('memory_limit', '512MB'); // why
		
		header('Content-Type: application/octet-stream');
		header('Content-Disposition: attachment; filename="chat-archive-'.date('YmdHis').'.tar.gz"');
		header('Content-Encoding: none;'); // request disabling gzip buffering
		
		passthru('/bin/tar cz --transform \'s~.*/([^/]+/)~\\1~gx\' --files-from '.escapeshellarg($flist));
		
		unlink($flist);
	}
	
	/**
	 * @return string Temporary filename
	 */
	protected static function writeFileList() {
		
		$allfiles = [];
		
		foreach(getHubs() as $id => $hubinfo) {
			
			foreach(monthrange($hubinfo[2], $hubinfo[3], $hubinfo[4], $hubinfo[5]) as $ympair) {
				list($y, $m) = $ympair;
				$chatfile = ArchiveState::getLogFileNameFor($hubinfo, $y, $m);
				
				if (file_exists($chatfile)) {
					$allfiles[] = $chatfile;
				}
			}
		}
		
		$flist = tempnam(sys_get_temp_dir(), 'archive');
		
		file_put_contents($flist, implode("\n", $allfiles));
		
		return $flist;
	}
	
	protected static function passthru_alt($cmd) {		
		$ph = popen($cmd, "r");
		for(;;) {
			$ret = fread($ph, 8192);
			if ($ret === false) {
				break;
			}
			
			echo $ret;
			flush();
		}
		pclose($ph);
	}

}

