<?php

/**
 * 
 * @param type $sz
 */
function redirect($sz) {
	header('Location: '.$sz);
	die();
}

/**
 * 
 * @param type $sz
 * @return type
 */
function hesc($sz) {
	return @htmlentities($sz, ENT_QUOTES | ENT_SUBSTITUTE, 'UTF-8');
}

/**
 * 
 * @param integer $d Range [1..12]
 * @return string Abbreviated month name
 */
function month($d) {
	return date("M", mktime(0, 0, 0, $d, 1, 2010)); // year doesn't matter
}

/**
 * 
 * @param type $val
 * @param type $min
 * @param type $max
 * @return type
 */
function clamp($val, $min, $max) {
	return max($min, min($max, $val));
}

/**
 * 
 * @param type $x
 * @return type
 */
function hasGet($x) {
	return array_key_exists($x, $_GET);
}

/**
 * Pack a year/month tuple into a single comparable int.
 *
 * @param int $y Year
 * @param int $m Month, in the range 1..12
 * @return int
 */
function ym2x($y, $m) {
	$m_0_11_based = $m - 1;
	return ($y * 12) + $m_0_11_based;
}

/**
 *
 */
function x2ym($x) {
	$y = floor($x / 12);
	$m_0_11_based = $x - ($y * 12);
	return [$y, $m_0_11_based + 1];
}

/**
 *
 * @param int $y Year
 * @param int $m Month, in the range 1..12
 * @return \Generator Months in the range 1..12
 */
function monthrange($y1, $m1, $y2, $m2) {
	$min = ym2x($y1, $m1);
	$max = ym2x($y2, $m2) + 1; // include right-hand bound
	
	for($i = $min; $i < $max; ++$i) {
		yield x2ym($i);
	}
}
